import 'package:flutter/foundation.dart';
import 'package:flutter/services.dart';

import 'tflite_flutter_plus_platform_interface.dart';

/// An implementation of [TfliteFlutterPlusPlatform] that uses method channels.
class MethodChannelTfliteFlutterPlus extends TfliteFlutterPlusPlatform {
  /// The method channel used to interact with the native platform.
  @visibleForTesting
  final methodChannel = const MethodChannel('tflite_flutter_plus');

  @override
  Future<String?> getPlatformVersion() async {
    final version = await methodChannel.invokeMethod<String>('getPlatformVersion');
    return version;
  }
}
